
#import "BibTeXObject.h"

char	*initString = "\n\n@article{newKey,note={new entry}\n}\n";


@implementation BibTeXObject


- initFromStream:(NXStream *)aStream owner:myFile
{	
	[super init];
	theStream = aStream;
	owner = myFile;
	c = NXGetc( theStream );
	if( [self pickUpItem] ) return self;
	//if( [self parseSelf] ) return self;	// tut
	return [self free];
}


- fileObject
{
	return owner;
}


- (NXStream	*)stream
{
	return theStream;
}


- setRange:(locType)range
{
	
	locInput = range;
	NXSeek(theStream, locInput.start-1, NX_FROMSTART);
	c = NXGetc( theStream );
	[self pickUpItem];
	return self;
}


- (int)line
{
	return firstLine;
}


- (locType)range
{
	return locInput;
}


- (locType)key
{
	return myKey;
}


- (int)entryType
{
	return myType;
}


- (char *)buffer
{
	char *theBuffer;
	int	length, maxLength;
	
	NXGetMemoryBuffer(theStream, &theBuffer, &length, &maxLength);
	return theBuffer;
}

// !! the calling object has to guarantee the buffer of
// appropriate size !!
- (char *)copy:(int)start :(int)length toBuffer:(char *)buffer
{
	int i;
	
	NXSeek(theStream, start, NX_FROMSTART);
	for( i=0; i<length; i++ ){
		buffer[i] = NXGetc( theStream );
	}
	buffer[i] = '\0';
	return buffer;
}


- (char *)copyRange:(locType)r toBuffer:(char *)buffer
{
	return [self copy:r.start :r.length toBuffer:buffer];
}


- setStringOf:(locType)r to:strField
{
	char *theBuffer;
	char ccc;
	int	inx = r.start + r.length;
	int	length, maxLength;
	
	NXGetMemoryBuffer(theStream, &theBuffer, &length, &maxLength);
	ccc = theBuffer[ inx ];
	theBuffer[ inx ] = '\0';	// overwrite	

	[strField setStringValue:&theBuffer[ r.start ]];
	theBuffer[ inx ] = ccc;	// old value
	return self;
}


- (locType)fieldFor:(int)fieldType
{
	return [BibTexParser fieldFor:fieldType];
}


- copyToStream:(NXStream *)str
{
	char *theBuffer;
	int	length, maxLength;
	int	count;
	
	NXGetMemoryBuffer( [self stream], &theBuffer, &length, &maxLength);

	for( count=0; count<locInput.length; count++ ){
		NXPutc( str, theBuffer[ locInput.start + count ] );
	}
	return self;
}


- (char)quoteCharForFieldAt:(locType)r
{
	char quoteChar;

	if( r.length==0 ) return '\0';
	NXSeek(theStream, r.start-1, NX_FROMSTART);
	quoteChar = NXGetc( theStream );
	if( quoteChar==LBRACE ) return LBRACE;
	if( quoteChar=='"' ) return '"';
	return '\0';

}


@end
