
#import <appkit/appkit.h>

#define MAXBUFFERS	50



@interface BibTexView:View
{
	id		theObject;
	id		theFile;
	id		inspector;
	id		keyField;
	id		keyForm;
	id		noteMatrix;
	id		popUpButton;
	id		popUpList;
	id		popUpListNew;
	id		popUpListString;
	id		popUpListPreamble;
	id		popUpListComment;
	id		preferences;
	id		entryNameList;
	id		configList;
	id		entryForm;
	id		noteView;
	id		clearButton;
	id		revertButton;
	id		addButton;
	id		replaceButton;
	id		newButton;
	id		bufferedButton;
	id		positionField;
	id		leftBraceButton;
	id		rightBraceButton;
	id		scrollView;
	id		charMatrix;
	id		theFont;
	NXRect	windowFrame, minTextFrame, newWindowFrame;
	int		actualRow;	// selected NOTE-button
	int		entryType;
	unsigned int	entryFormMask, scrollViewMask;
	id		objWithThisKey;
	BOOL	noteIsDirty;
	BOOL	isDirty;
	BOOL	textDidChange;
	BOOL	prefsDidChange;
	BOOL	isNew;
	BOOL	keyIsValid;
	BOOL	cooked;
	id	textBuffer[MAXBUFFERS];

}

- displayEntry:sender;
- prefsDidChange;
- setEntry:anObject inFile:file;
- clear:sender;
- addEntry:sender;
- newEntryFor:file;
- replaceEntry:sender;
- makeEntry:sender;
- revert:sender;
- noteSelect:sender;
- mainBrace:sender;
- drawTemplate:(int)entryType;
- specialMatrix:sender;
- showCharPanel:sender;
- setBacking:sender;
@end


/***************
	description of the various states
	
	file	object	dirty	|	revert	add	to file		replace entry
	- - - - - - - - - - - - | - - - - - - - - - - - - - - - - - - - - -
	  0		   0	  0		|	  0			0				0
	  0		   0	  X		|	  0			0				0
	  0		   X	  0		|	  		impossible state
	  0		   X	  X		|	  		impossible state
	  X		   0	  0		|	  0			0				0
	  X		   0	  X		|	  0			X (1)			0
	  X		   X	  0		|	  0			0				0
	  X		   X	  X		|	  X			X (1)			X (2) <---(3)

	(1) provided 'key' is unique (not yet in the file)
	(2) 'key' is unique or is the object's key
	(3) sets dirty to 0 after 'add...' or 'replace...'


***************/


