
#import "BrowserController.h"
#import "Controller.h"
#import "MyCell.h"
#import "BibliographicFile.h"
#import "BibliographicObject.h"
#import "Preferences.h"
#import "DragView.h"


//////#define VERY_LAZY

@implementation BrowserController

- prRect:(NXRect)r
{
	fprintf( stderr, "x=%d y=%d w=%d h=%d\n",
		(int)r.X, (int)r.Y, (int)r.W, (int)r.H );
	return self;
}

- (void) setUpPopUpListAt:(int)inx
{
	NXRect	titleFrame;

	if( [theBrowser getTitleFrame:&titleFrame ofColumn:inx]==NULL ) return;

	titleFrame.W -= 4;
	titleFrame.H -= 4;
	titleFrame.X += 2;
	titleFrame.Y += 2;

	popUpMatrix[inx].button = [[Button alloc] initFrame:&titleFrame];
	[popUpMatrix[inx].button setTitle:"keys"];
	popUpMatrix[inx].list = [[PopUpList alloc] init];
	NXAttachPopUpList( popUpMatrix[inx].button, popUpMatrix[inx].list );
	[popUpMatrix[inx].list addItem:"entries"];
	[popUpMatrix[inx].list sizeToFit];
	[[popUpMatrix[inx].list setAction:@selector(popUp:)] setTarget:self];
	[theBrowser addSubview:popUpMatrix[inx].button];
	[[popUpMatrix[inx].list itemList] setTag:inx];
	popUpMatrix[inx].selectedRow = -1;
}


- setUp
{
	int		i;

	preferences = [Preferences new];

	[theBrowser setCellClass:[MyCell class]];
	[theBrowser setTitle:"bibFile" ofColumn:0];
	[theBrowser setAction:@selector(singleClick:)];
	[theBrowser setDoubleAction:@selector(doubleClick:)];
	[theBrowser reuseColumns:YES];
	//[theBrowser getTitleFromPreviousColumn:NO];
	//	the theBrowser must be the first responder :
	[theBrowser acceptArrowKeys:YES andSendActionMessages:YES];
	[theBrowser setTarget:self];
	[theBrowser setAutodisplay:NO];
	
	[theBrowser acceptArrowKeys:YES andSendActionMessages:YES];

	for(i=0; i<=1/*[theBrowser lastVisibleColumn]*/; i++){
		[self setUpPopUpListAt:i];
	}

	return self;
}


// both "icons" are of class DragView
- setUpIcons:fIcon :eIcon
{
	entryIcon = eIcon;
	fileIcon = fIcon;
	[fileIcon clear];
	[entryIcon clear];
	return self;
}


- popUp:sender	// sender is matrix of a popUpList
{
	int	tag = [sender tag];
	
	if( tag<0 ) return self;
	popUpMatrix[tag].selectedRow = [sender selectedRow];
	[theBrowser doClick:[theBrowser matrixInColumn:(tag>0)?tag-1:0]];
	return self;
}


- singleClick:sender	// sender is NXBrowser
{
	int	i = 0;
	int	selCol  = [sender selectedColumn];
	id	matrix  = [sender matrixInColumn:selCol];
	id	selList = [matrix getSelectedCells:nil];
	char	locBuffer[256];

	///fprintf( stderr, "(browser)selcol = %d\n", selCol );

	if( [selList count]==0 ){	// nothing selected
		[sender getPath:locBuffer toColumn:selCol];
		if( locBuffer[0] == '\0' ){
			locBuffer[0] = '/';
			locBuffer[1] = '\0';
		}
		[sender setPath:locBuffer];
		[entryIcon clear];
		if( selCol==0 ) [fileIcon clear];
		[[NXApp delegate] browserDidChange:sender];
		[[[bibWindow reenableDisplay] displayIfNeeded] reenableFlushWindow];
		[sender displayColumn:1];
		[selList free];
		return self;
	}

	if( selCol==0 ){
		[[NXApp delegate] P:self];
		[fileIcon setList:selList];
		[entryIcon clear];
	
		[sender displayColumn:1];
		[selList free];
		[[NXApp delegate] browserDidChange:sender];
		[[[bibWindow reenableDisplay] displayIfNeeded] reenableFlushWindow];
		[[NXApp delegate] V:self];
		return self;
	}

	//	show column entrytypes ?
	if( (selCol==1) && ([self selectedPopUpInCol:selCol]==1) ){
		// nothing to do (so far)
		[selList free];
		[[NXApp delegate] browserDidChange:sender];
		[[[bibWindow reenableDisplay] displayIfNeeded] reenableFlushWindow];
		return self;
	}

	//	col2 is selected (show the keys) or
	//  col1 is selected and keys shall be shown
	
	[entryIcon setList:selList];

	[[NXApp delegate] browserDidChange:sender];
	
	//[selectionButton display];
	while( popUpMatrix[i].button ){
		[popUpMatrix[i++].button display];
	}
	[[[bibWindow reenableDisplay] displayIfNeeded] reenableFlushWindow];
	return self;
}


- doubleClick:sender
{
	NXTextStyle *theStyle;

	int	selCol;
	id	matrix;
	id	fileObj;

	if( BIBTEST==NO ) return self;	// @@@1.1
	
	selCol = [sender selectedColumn];
	matrix = [sender matrixInColumn:selCol];
	fileObj = [[matrix selectedCell] fileObject];

	if( selCol==0 ){
		[fileObj showFile];	
		return self;
	}
	if( selCol==1 ){
		id	obj = [fileObj objectAt:[matrix selectedRow]];
		locType theRange = [obj range];
		char *buf = [obj buffer];
		
		[testDocView setSel:0 :[testDocView textLength]];
		theStyle = [testDocView defaultParaStyle];
		[testDocView setParaStyle:theStyle];

		[testDocView replaceSel:&buf[theRange.start] length:theRange.length];		
		[testDocView setSel:0 :0];
		[testDocView scrollSelToVisible];
		[testPanel setDelegate:self];
		[testPanel orderFront:self];
		[asciiDragView setTextObject:testDocView];

		if(0)[obj callTheEditorForFile:[fileObj fullPath] inLine:[obj line]];
		return self;
	}
	return self;
}


- (int)fillColZero:locMatrix
{
	int i;
	id	listOfFiles = [[NXApp delegate] listOfFiles];

//fprintf( stderr, "fillColZero\n" );
	for( i=0; i<[listOfFiles count]; i++ ){
		id	newCell;
		id	fileObj = [listOfFiles objectAt:i];

		[locMatrix addRow];
		newCell = [locMatrix cellAt:i :0];
		[[[[newCell	setStringValue:[fileObj fileName]]
					setLeaf:NO]
					setLoaded:YES]
					setObject:nil inFile:fileObj];
	}
	return [listOfFiles count];
}



- (int)fillMatrix:locMatrix inColumn:(int)column withKeysFor:(int)index
{
	int	i;
	id	newCell;
	id	file = [[[NXApp delegate] listOfFiles] objectAt:index];
	id	litObj = [file objectAt:0];

	[[bibWindow disableDisplay] disableFlushWindow];//  enabled in singleClick

	for( i=0; litObj; i++ ){
		[locMatrix addRow];
		newCell = [locMatrix cellAt:i :0];
		[litObj setStringOf:[litObj key] to:newCell];
		[[newCell	setLeaf:YES]
					setObject:litObj inFile:file];
		[newCell 	setLoaded:YES];
		litObj = [file objectAt:i+1];
	}
	return i;
}



- (int)fillMatrix:locMatrix withKeysFor:(int)index
{
	int	i, cnt;
	id	matrix = [theBrowser matrixInColumn:1];
	id	theCell = [matrix selectedCell];
	id	file = [theCell fileObject];
	id	litObj = [file objectAt:0];
	id	newCell;

	[[bibWindow disableDisplay] disableFlushWindow];//  enabled in singleClick

	for( i=0, cnt=0; litObj; i++ ){
		if( [litObj entryType]!=index ){
			litObj = [file objectAt:i+1];
			continue;
		}
		[locMatrix addRow];
		newCell = [locMatrix cellAt:cnt :0];
		[litObj setStringOf:[litObj key] to:newCell];
		[[newCell	setLeaf:YES]
					setObject:litObj inFile:file];
		[newCell 	setLoaded:YES];
		litObj = [file objectAt:i+1];
		cnt++;
	}
	return cnt;
}


- (int)fillMatrix:locMatrix withEntriesAt:(int)index
{
	int		i;
	id		newCell;
	id		file = [[[NXApp delegate] listOfFiles] objectAt:index];
	id		entryNameList = [preferences entryNameList];

	[[bibWindow disableDisplay] disableFlushWindow];// enabled in singleClick
	for( i=0; i<[entryNameList count]; i++ ){
		[locMatrix addRow];
		newCell = [locMatrix cellAt:i :0];
		[newCell setStringValue:(const char *)[entryNameList objectAt:i]];
		[[newCell setLeaf:NO] setObject:nil inFile:file];
		[newCell setLoaded:YES];
	}
	return [entryNameList count];
}


- (int)selectedPopUpInCol:(int)col
{
	int	sel = popUpMatrix[col].selectedRow;
	return ( sel<0 )? 0 : sel;
}


- browserDidScroll:sender
{
	if(0)fprintf( stderr, "%s didScroll %d %d (%d)\n",
		[sender name],
		[sender firstVisibleColumn],
		[sender lastVisibleColumn], [sender lastColumn] );
	[self windowDidResize:sender];
	return self;
}


#ifndef VERY_LAZY
// "normal" delegate
- (int)browser:sender fillMatrix:locMatrix inColumn:(int)column
{
	int	count;
	id	matrix = [theBrowser matrixInColumn:column-1];
	int	index = [matrix selectedRow];

	if( popUpMatrix[column].button==nil ){
		//fprintf( stderr, "new button\n" );
		[self setUpPopUpListAt:column];
		[popUpMatrix[column].button display];
	}

	if( column==0 ){
		count = [self fillColZero:locMatrix];
		[[NXApp delegate] colZeroIsFilled];
		return count;
	}
	
	if( column==1 ){
		int	sel = popUpMatrix[column].selectedRow;
		if( (sel<=0) )
			return
				[self fillMatrix:locMatrix inColumn:column withKeysFor:index];

		return	[self fillMatrix:locMatrix withEntriesAt:index];
	}

	if( column==2 ){
		return [self fillMatrix:locMatrix withKeysFor:index];
	}
	return 0;	
}
#endif


#ifdef VERY_LAZY
// "very lazy" delegate
- (int)browser:sender getNumRowsInColumn:(int)column
{
	id	fileObj;

	if( column==0 ){
		return [[[NXApp delegate] listOfFiles] count];
	}
 
	if( column==1 ){
		fileObj = [[[sender matrixInColumn:0] selectedCell] fileObject];
		return [fileObj entries];
	}

fprintf( stderr,"browser: getNumRowsInColumn %d\n", column );
	return 2;
}


// "very lazy" delegate
- browser:sender loadCell:cell atRow:(int)row inColumn:(int)column
{
	id	fileObj;
	id	entryObject;

	if(column==0){
	 	fileObj = [[[NXApp delegate] listOfFiles] objectAt:row];
		[cell setStringValue:[fileObj fileName]];
		[cell setLeaf:NO];
		[cell setLoaded:YES];
		[cell setObject:nil inFile:fileObj];
		return self;
	}
	if(column==1){
		fileObj = [[[sender matrixInColumn:0] selectedCell] fileObject];
		entryObject = [fileObj objectAt:row];
		[cell setLeaf:YES];
		[cell setLoaded:YES];
		[entryObject setStringOf:[entryObject key] to:cell];
		[cell setObject:entryObject inFile:fileObj];
		return self;
	}
	return self;
}
#endif


//	returns the new state of the menuCell
	// YES = enabled
	//	NO = disabled

- (BOOL)updateMenuFor:menuCell
{
	BOOL	newState=NO;	// .. and the compiler keeps silent

	switch( [menuCell tag] ){
		case CUT			:
		case COPY			:
		case PASTE			:
		case SELECTALL		:
		case ENTERSELECTION : newState = YES; break;

		default : newState = [[NXApp delegate]updateMenuFor:menuCell];
				  break;
		}

	return newState;
}


// copy selected text to findPasteBoard

- enterSelection:sender
{
	[[NXApp delegate] enterSelectionFor:testDocView];

	return self;
}


- windowDidResize:sender
{
	NXRect	titleFrame;
	int		i = 0;
	while( popUpMatrix[i].button ){
		if( [theBrowser getTitleFrame:&titleFrame ofColumn:i] ){
			titleFrame.W -= 4;
			titleFrame.H -= 4;
			titleFrame.X += 2;
			titleFrame.Y += 2;
			if( [popUpMatrix[i].button superview]==nil )
				[theBrowser addSubview:popUpMatrix[i].button];
			[popUpMatrix[i].button setFrame:&titleFrame];
		}
		else [popUpMatrix[i].button removeFromSuperview];
		i++;
	}
	return self;
}


- selectAllIn:matrix column:(int)col
{
#ifdef VERY_LAZY
	int	count = [matrix cellCount];

	while( count-- )
		[theBrowser getLoadedCellAtRow:count inColumn:col];
#endif

	[[NXApp delegate] selectAllEntriesIn:matrix];
	return self;
}


- (BOOL)browser:sender columnIsValid:(int)column
{
	return YES;
}


- (BOOL)browser:sender selectCell:(const char *)entry inColumn:(int)column
{
	return YES;
}


@end



/***************	category for NXBrowser	***********/

@implementation NXBrowser(selection)

- selectAll:sender	// sender is a matrix
{
	int	last = [self lastColumn];
	id	matrix = [self matrixInColumn:last];

	[matrix selectAll:sender];
	if( [[self delegate] respondsTo:@selector(selectAllIn:column:)] ){
		[[self delegate] selectAllIn:matrix column:last];
	}
	return self;
}


@end

