
#import <appkit/appkit.h>

#define BIBTEST		NO

/********	class hierarchy of this Application:

					Object
					  |
			-------------------------
			|						|
	BibliographicObject		BiblioGraphicFile
			|
		BibTexParser
			|
		BibTeXObject

*************/

#define	X	origin.x
#define	Y	origin.y
#define	W	size.width
#define	H	size.height


/********		tags of menu cells		***********/

//		Document
#define	DOCUMENT	2
#define	OPEN		21
#define	NEW			22
#define	SAVE		23
#define	SAVEAS		24
#define	SAVETO		25
#define	SAVEALL		26
#define	REVERT		27
#define	CLOSE		28

//		File
#define	EDIT		3
#define	CUT			31
#define	COPY		32
#define	PASTE		33
#define	SELECTALL	34
#define	FIND		35
#define	FINDPANEL		351
#define	FINDNEXT		352
#define	FINDPREVIOUS	353
#define	ENTERSELECTION	354
#define	JUMPTOSELECTION	354

//		LaTeX
#define	PREVIEW		6
#define	PRVWINDOW	61
#define	RUNLATEX	62
#define	RUNRTF		63
#define	RUNHTML		64
#define	PRINT		65



@interface Controller:Object
{
	id	infoPanel;
	id	hostNameText;
	id	procTypeText;
	id	screenTypeText;
	id	screenSizeText;

	id	browserController;
	id	shelfController;
	id	bibWindow;
    id	errorScroller;
	id	openPanel;
	id	listOfFiles;
	id	litBrowser;
	id	entryButton;
	id	newEntryButton;
	id	fileButton;
	id	findButton;
	id	findObject;
	id	inspector;
	id	betweenButton;

	id	texObject;
	id	LaTeXButton;
	id	deleteButton;
	id	bufferedButton;

	id	lastMainObject;
	id	lastMainFile;

	id	iconScrollView;
	NXStream *masterStream;
	int		streamLength;
	int		streamMaxLength;
	char	*streamBuffer;

	id	preferences;
	id	fileNameText;
	id	fileOnShelfText;
	id	fileSizeText;
	id	fileTimeText;
	id	numberOfEntriesText;
	
	NXAtom	MyListPboardType;
	BOOL	filenameChanged;
}

- info:sender;
- suggestion: sender;
- newFile:sender;
- open:sender;
- revertToSaved:sender;
- shelfText:(const char *)txt;
- save:sender;
- saveAs:sender;
- close:sender;
- preferences:sender;
- entryMatrixFor:aFile;
- update:obj for:aFile isNew:(BOOL)q shiftLit:(BOOL)sl;
- objectForFileNamed:(const char *)fName;
- selectFile:aFile;
- (void)setFindText;
- selectAllEntriesIn:matrix;
- selectList:aList inColumn:(int)col;
- findString:sender;
- listOfFiles;
- (void)colZeroIsFilled;
- (BOOL) openFile:(const char *)fullName;
- LaTeXFromList:(List *)aList;
- LaTeX:sender;
- printDvi:sender;
- showPanel:sender;
- (void)P:sender;
- (void)V:sender;
- browserDidChange:sender;
- (int)semaphore:sender;
- deleteEntry:sender;
- newEntry:sender;
- enterSelectionFor:responder;
- setBacking:sender;
- theShelf;

- showReadme:sender;
- showUsage:sender;

@end


/***************		category for the Text class		***********/

@interface Text(printf)

- (void) addText:(char *)theText;
- (void) clearText;
- (void) clearAndWriteText:(char *)theText;
- (void) printf:(const char *)format, ...;

@end




/***************		category for the PopUpList class	***********/

@interface PopUpList(sizeTheButton)

- sizeButton:button;

@end



