
#import <appkit/appkit.h>

#define	LBRACE	'{'
#define	RBRACE	'}'

#define	REQUIRED	1
#define	OPTIONAL	2
#define	CUSTOM		3

#define	SHOW		4
#define	LARGE		8


#define	MODESIZE	20


typedef	struct{
	NXAtom	fieldName;	// fieldname
	int		start;		// Parser : first character of entry
	int		length;		// Parser : length of entry
	unsigned short	mode[MODESIZE];	// mode for all entryTypes
}configListType;


//	toggle list structure
typedef	struct{
	int		entryIndex;
	NXAtom	txt0;
	NXAtom	txt1;
	int		tglButtonInx;
	int		formInx;
	id		tglButton;
	unsigned char isInWindow;
	unsigned char state;
	unsigned char label;
}toggleListType;


@interface Preferences:Object
{
	id	configList;
	id	entryNameList;
	id	fieldNameList;
	int	token;
	const char	*tempDir;
	const char	*libDir;
	const char	*configurationFile;
	const char	*shelfFile;
	const char	*templateFile;
	NXStream	*configStream;

	int	lineNumber;
	int	entryIndex;
	int	fieldConversion;
	int	entryConversion;
	id	fieldRadio;
	id	entryRadio;
	id	prefPanel;
	id	popUpButton;
	id	popUpList;
	id	scrollView;
	//id	fieldNameMatrix;
	id	requestMatrix;
	//id	showMatrix;
	id	sizeMatrix;
	id	validButton;
	id	fieldNameField;

	id	theShelf;
	id	showBox;
	id	entryView;
	id	shelfView;
	id	filenameView;
	id	tableViewBox;
	id	tableView;
	int	rowCount;
	int	columnCount;
	id	shelfMatrix;
	
	id	inspector;
	id	addButton;
	id	renameButton;
	id	deleteButton;
	id	removeTempButton;
	id	defaultForm;
	
	toggleListType toggleList[20];
	BOOL	tableViewIsLoaded;
	BOOL	removeTemp;
}

- (int)findIndexFor:(int)inx :(unsigned char)label;
- (toggleListType *)toggleList;
- saveConfiguration:sender;
- saveShelf:sender;
- parse;
- show;
- showButton:sender;
- fieldFormatButton:sender;
- entryFormatButton:sender;
- removeTempButton:sender;
- (BOOL)shallRemoveTempFiles;
- openOnLaunch:sender;
- entryNameList;
- fieldNameList;
- configList;
- shelfDidChange;
- addFieldName:sender;
- changeFieldname:sender;
- deleteFieldname:sender;
- (void)addCustomField:(char *)name;
- (int)indexOfFieldname:(const char *)name;
- (int)indexOfEntryname:(const char *)name;
- (const char *)tempDirectory;
- (const char *)libDirectory;
- (const char *)templateFile;
- (const char *)shelfFile;
@end
