
#import <appkit/appkit.h>
@class DragView;
@class BibliographicFile;

typedef struct {
	id	theView;
	id	theBox;
	id	theFile;
	int	state;
}shelfType;


#define MAXCOUNT	40

@interface Shelf:View
{
	id			preferences;
	id			scrollView;
	int			count;			//	number of boxes on the shelf
	int			iconsPerRow;	// number of icons per row
	NXRect		boxRect;		// size of a box on shelf
	NXAtom		MyListPboardType;
	NXStream	*protypeStream;	// typed stream from which boxes can be created
	shelfType	shelfBox[MAXCOUNT];	// description array of all boxes
}

// initialize a shelf
- (void) setBoxPrototype:(NXStream *)aStream;
- (Box *) readBoxFromStream:(NXStream *)theStream;
- (BOOL) loadShelfFromFile:(const char *)file;

// find index of a box
- (int)indexOfBox:(Box *)box;
- (int)indexOfBoxWithIcon:(DragView *)view;
- (int)indexOfBoxForFile:(BibliographicFile *)aFile;
- (int)indexOfBoxNamed:(const char *)fileName;

// properties of an icon
- (const char *)filenameOfIconAt:(int)inx;
- (int)getstateOfIconAt:(int)inx;
- setState:(int)state forIconAt:(int)inx;

// set fileparameter of a box
- attachFile:(const char *)fName toObject:(BibliographicFile *)obj;
- attachObject:(BibliographicFile *)obj toFile:(const char *)fName;
- detachObject:(BibliographicFile *)obj;

// remove box from shelf
- (void) removeBoxAt:(int)inx;
- (void) removeBoxWithIcon:(DragView *)theView;

// insert box 
- (int)insertBox:(Box *)box at:(int)inx;
- (int)insertBox:(Box *)box;

// display
- (void)sizeShelf;
- (void)setCoordinates:(NXRect *)r at:(int)inx;
- (void)redrawShelf;

@end
