(display "You are in a maze of twisty little editors, all different.")

;
; Set some miscellaneous stuff
;
; (set-input-mode t nil)
; (setq manual-program "man")
; (setq backup-by-copying-when-linked t)
; (setq text-mode-hook 'turn-on-auto-fill)
; (setq term-setup-hook 'enable-arrow-keys)

;
; Set the load path
;

(setq-default load-path '("/Unix/lib/emacs/lisp"
			  "/usr/lib/emacs/lisp" nil))

;
; the setq objective-C-mode-hook is not absolutely necessary, but I use it in
; order to override the objc-mode defaults of /* */ comments at col 70something
;

(autoload 'objective-C-mode "objc-mode-no-untabify"
          "Objective-C mode" t nil)

(setq objective-C-mode-hook '(lambda ()
                               (setq comment-column 48)
;			       (setq objective-C-indent-level 4)
                               (setq comment-start "//")
                               (setq comment-end "")))

;
; set all the special file types that are recognized and what modes
; they are tied to here
;

(setq auto-mode-alist (append   '(("\\.c" . objective-C-mode)
				  ("\\.m" . objective-C-mode)
				  ("\\.h" . objective-C-mode)
				  ("\\.scm$" . scheme-mode)
				  ("\\.sml$" . sml-mode)
				  ("\\.sig$" . sml-mode))
				auto-mode-alist))

; Don't scroll past EOF....

(defun next-line-no-mod (arg)
  "Like next-line but does not add lines at eof."
  (interactive "p")
  (setq this-command 'next-line)
  (next-line-internal arg)
  )

;
; Bind some keys for minimal gosmacs compatibility.
;

(global-set-key "\C-x\C-l"	'goto-line)
(global-set-key "\C-c\C-e"	'compile)
(global-set-key "\C-x\C-f"	'find-file)
(global-set-key "\e\e"		'minibuffer-complete)
(global-set-key "\M-p"		'prc-buffer)           ; print the buffer
(global-set-key "\C-xn"		'other-window)
(global-set-key "\C-xp"		'(lambda () (interactive) (other-window -1)))
(global-set-key "\M-r"		'replace-string)
(global-set-key "\C-n"		'next-line-no-mod)

;
; No Trojan horses, please.
;
(setq inhibit-local-variables t)

;
; Define C indenting style
;

(setq c-indent-level 2)
(setq c-continued-statement-offset 2)
(setq c-continued-brace-offset 0)
(setq c-brace-offset -2)
(setq c-brace-imaginary-offset 0)
(setq c-argdecl-indent 0)
(setq c-label-offset -2)

;
; prc utility stuff
;

(autoload 'prc-buffer "prc" "enscript buffer." t)
(autoload 'prc-region "prc" "enscript region." t)
